// HyperMD, copyright (c) by laobubu
// Distributed under an MIT license: http://laobubu.net/HyperMD/LICENSE
//
// POWERPACK for "addon/paste"
//
// This module provides `TurndownConvertor`, which can convert copied HTML into Markdown.
//
// :bulb: **Hint**:
//
// This module also supports GFM extensions (eg. tables) via [turndown-plugin-gfm](https://www.npmjs.com/package/turndown-plugin-gfm).
// Load `turndown-plugin-gfm` after this module and it will be automatically used while pasting.
//
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};

(function (mod){ //[HyperMD] UMD patched!
  /*commonjs*/  ("object"==typeof exports&&"undefined"!=typeof module) ? mod(null, exports, require("turndown"), require("../addon/paste")) :
  /*amd*/       ("function"==typeof define&&define.amd) ? define(["require","exports","turndown","../addon/paste"], mod) :
  /*plain env*/ mod(null, (this.HyperMD_PowerPack = this.HyperMD_PowerPack || {}, this.HyperMD_PowerPack["paste-with-turndown"] = {}), TurndownService, HyperMD.Paste);
})(function (require, exports, TurndownService, paste_1) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.getTurndownService = exports.TurndownConvertor = void 0;
    TurndownService = __importStar(TurndownService);
    var TurndownConvertor = function (html) {
        // strip <a> without href
        html = html.replace(/<a([^>]*)>(.*?)<\/a>/gi, function (s, attrs, content) {
            if (!/href=/i.test(attrs))
                return content;
            return s;
        });
        // maybe you don't need to convert, if there is no img/link/header...
        if (!/\<(?:hr|img|h\d|strong|em|mark|ins|sub|sup|strikethrough|table|a|b|i|del)(?:\s.*?|\/)?\>/i.test(html))
            return null;
        var turndownService = exports.getTurndownService();
        if (turndownService)
            return turndownService.turndown(html);
        return null;
    };
    exports.TurndownConvertor = TurndownConvertor;
    exports.getTurndownService = (function () {
        var service = null;
        return function () {
            if (!service && typeof TurndownService === "function") {
                var opts = {
                    headingStyle: "atx",
                    hr: "---",
                    bulletListMarker: "*",
                    codeBlockStyle: "fenced",
                    fence: "```",
                    emDelimiter: "*",
                    strongDelimiter: "**",
                    linkStyle: "inlined",
                    linkReferenceStyle: "collapsed",
                };
                service = new TurndownService(opts);
                if (typeof turndownPluginGfm !== "undefined") {
                    service.use(turndownPluginGfm.gfm);
                }
            }
            return service;
        };
    })();
    if (typeof TurndownService != "undefined") {
        // Use this convertor as default convertor
        paste_1.defaultOption.convertor = exports.TurndownConvertor;
    }
    else {
        if (window["ECHOMD_DEBUG"]) {
            console.error("[HyperMD] PowerPack paste-with-turndown loaded, but turndown not found.");
        }
    }
});
